#include "pplite_test.hh"
// FIXME. to do
// test Rational constructors and assignment operator

bool
test01() {
  // *default* constructor + bool
  Rational i;
  return check_print(i, "0");
}

bool
test02() {
  // static zero member
  return check_print(Rational::zero(), "0");
}

bool
test03() {
  // static one member
  return check_print(Rational::one(), "1");
}

bool
test04() {
  // unsigned rational constructor
  Rational i(10L );
  Rational j( 1.2f);
  Rational k(  .1);
  bool t1 = check_print((i.get_num() * 10) / (i.get_den()), "100");
  bool t2 = check_print((j.get_num() * 10) / (j.get_den()), "12");
  bool t3 = check_print((k.get_num() * 10) / (k.get_den()), "1");

  return t1 && t2 && t3;
}

bool
test05() {
  // copy constructor
  Rational j(8.6);
  Rational i(j);

  return (i.get_num() == j.get_num()) && (i.get_den() == j.get_den());
}

bool
test06() {
  // move constructor
  Rational i(Rational(-8.5));

  return check_print((i.get_num() * 10) / (i.get_den()), "-85");
}

BEGIN_MAIN
  DO_TEST(test01);
  DO_TEST(test02);
  DO_TEST(test03);
  DO_TEST(test04);
  DO_TEST(test05);
  DO_TEST(test06);
END_MAIN
